<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ProductImage StructType
 * @subpackage Structs
 */
class ProductImage extends AbstractStructBase
{
    /**
     * The url
     * @var string
     */
    public $url;
    /**
     * The order
     * @var int
     */
    public $order;
    /**
     * Constructor method for ProductImage
     * @uses ProductImage::setUrl()
     * @uses ProductImage::setOrder()
     * @param string $url
     * @param int $order
     */
    public function __construct($url = null, $order = null)
    {
        $this
            ->setUrl($url)
            ->setOrder($order);
    }
    /**
     * Get url value
     * @return string|null
     */
    public function getUrl()
    {
        return $this->url;
    }
    /**
     * Set url value
     * @param string $url
     * @return \StructType\ProductImage
     */
    public function setUrl($url = null)
    {
        // validation for constraint: string
        if (!is_null($url) && !is_string($url)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($url, true), gettype($url)), __LINE__);
        }
        $this->url = $url;
        return $this;
    }
    /**
     * Get order value
     * @return int|null
     */
    public function getOrder()
    {
        return $this->order;
    }
    /**
     * Set order value
     * @param int $order
     * @return \StructType\ProductImage
     */
    public function setOrder($order = null)
    {
        // validation for constraint: int
        if (!is_null($order) && !(is_int($order) || ctype_digit($order))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($order, true), gettype($order)), __LINE__);
        }
        $this->order = $order;
        return $this;
    }
}
