<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for SaveProductResponse StructType
 * @subpackage Structs
 */
class SaveProductResponse extends AbstractStructBase
{
    /**
     * The result
     * @var \StructType\ResultInfo
     */
    public $result;
    /**
     * The product
     * @var \StructType\ProductBasic
     */
    public $product;
    /**
     * Constructor method for SaveProductResponse
     * @uses SaveProductResponse::setResult()
     * @uses SaveProductResponse::setProduct()
     * @param \StructType\ResultInfo $result
     * @param \StructType\ProductBasic $product
     */
    public function __construct(\StructType\ResultInfo $result = null, \StructType\ProductBasic $product = null)
    {
        $this
            ->setResult($result)
            ->setProduct($product);
    }
    /**
     * Get result value
     * @return \StructType\ResultInfo|null
     */
    public function getResult()
    {
        return $this->result;
    }
    /**
     * Set result value
     * @param \StructType\ResultInfo $result
     * @return \StructType\SaveProductResponse
     */
    public function setResult(\StructType\ResultInfo $result = null)
    {
        $this->result = $result;
        return $this;
    }
    /**
     * Get product value
     * @return \StructType\ProductBasic|null
     */
    public function getProduct()
    {
        return $this->product;
    }
    /**
     * Set product value
     * @param \StructType\ProductBasic $product
     * @return \StructType\SaveProductResponse
     */
    public function setProduct(\StructType\ProductBasic $product = null)
    {
        $this->product = $product;
        return $this;
    }
}
