<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for StockItemForUpdateStockWithId StructType
 * @subpackage Structs
 */
class StockItemForUpdateStockWithId extends AbstractStructBase
{
    /**
     * The id
     * @var int
     */
    public $id;
    /**
     * The quantity
     * @var int
     */
    public $quantity;
    /**
     * The version
     * @var int
     */
    public $version;
    /**
     * The delist
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var bool
     */
    public $delist;
    /**
     * Constructor method for StockItemForUpdateStockWithId
     * @uses StockItemForUpdateStockWithId::setId()
     * @uses StockItemForUpdateStockWithId::setQuantity()
     * @uses StockItemForUpdateStockWithId::setVersion()
     * @uses StockItemForUpdateStockWithId::setDelist()
     * @param int $id
     * @param int $quantity
     * @param int $version
     * @param bool $delist
     */
    public function __construct($id = null, $quantity = null, $version = null, $delist = null)
    {
        $this
            ->setId($id)
            ->setQuantity($quantity)
            ->setVersion($version)
            ->setDelist($delist);
    }
    /**
     * Get id value
     * @return int|null
     */
    public function getId()
    {
        return $this->id;
    }
    /**
     * Set id value
     * @param int $id
     * @return \StructType\StockItemForUpdateStockWithId
     */
    public function setId($id = null)
    {
        // validation for constraint: int
        if (!is_null($id) && !(is_int($id) || ctype_digit($id))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($id, true), gettype($id)), __LINE__);
        }
        $this->id = $id;
        return $this;
    }
    /**
     * Get quantity value
     * @return int|null
     */
    public function getQuantity()
    {
        return $this->quantity;
    }
    /**
     * Set quantity value
     * @param int $quantity
     * @return \StructType\StockItemForUpdateStockWithId
     */
    public function setQuantity($quantity = null)
    {
        // validation for constraint: int
        if (!is_null($quantity) && !(is_int($quantity) || ctype_digit($quantity))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($quantity, true), gettype($quantity)), __LINE__);
        }
        $this->quantity = $quantity;
        return $this;
    }
    /**
     * Get version value
     * @return int|null
     */
    public function getVersion()
    {
        return $this->version;
    }
    /**
     * Set version value
     * @param int $version
     * @return \StructType\StockItemForUpdateStockWithId
     */
    public function setVersion($version = null)
    {
        // validation for constraint: int
        if (!is_null($version) && !(is_int($version) || ctype_digit($version))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($version, true), gettype($version)), __LINE__);
        }
        $this->version = $version;
        return $this;
    }
    /**
     * Get delist value
     * @return bool|null
     */
    public function getDelist()
    {
        return $this->delist;
    }
    /**
     * Set delist value
     * @param bool $delist
     * @return \StructType\StockItemForUpdateStockWithId
     */
    public function setDelist($delist = null)
    {
        // validation for constraint: boolean
        if (!is_null($delist) && !is_bool($delist)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($delist, true), gettype($delist)), __LINE__);
        }
        $this->delist = $delist;
        return $this;
    }
}
