<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for StockItemForUpdateStockWithSellerStockCode StructType
 * @subpackage Structs
 */
class StockItemForUpdateStockWithSellerStockCode extends AbstractStructBase
{
    /**
     * The sellerStockCode
     * @var string
     */
    public $sellerStockCode;
    /**
     * The quantity
     * @var int
     */
    public $quantity;
    /**
     * The version
     * @var int
     */
    public $version;
    /**
     * Constructor method for StockItemForUpdateStockWithSellerStockCode
     * @uses StockItemForUpdateStockWithSellerStockCode::setSellerStockCode()
     * @uses StockItemForUpdateStockWithSellerStockCode::setQuantity()
     * @uses StockItemForUpdateStockWithSellerStockCode::setVersion()
     * @param string $sellerStockCode
     * @param int $quantity
     * @param int $version
     */
    public function __construct($sellerStockCode = null, $quantity = null, $version = null)
    {
        $this
            ->setSellerStockCode($sellerStockCode)
            ->setQuantity($quantity)
            ->setVersion($version);
    }
    /**
     * Get sellerStockCode value
     * @return string|null
     */
    public function getSellerStockCode()
    {
        return $this->sellerStockCode;
    }
    /**
     * Set sellerStockCode value
     * @param string $sellerStockCode
     * @return \StructType\StockItemForUpdateStockWithSellerStockCode
     */
    public function setSellerStockCode($sellerStockCode = null)
    {
        // validation for constraint: string
        if (!is_null($sellerStockCode) && !is_string($sellerStockCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($sellerStockCode, true), gettype($sellerStockCode)), __LINE__);
        }
        $this->sellerStockCode = $sellerStockCode;
        return $this;
    }
    /**
     * Get quantity value
     * @return int|null
     */
    public function getQuantity()
    {
        return $this->quantity;
    }
    /**
     * Set quantity value
     * @param int $quantity
     * @return \StructType\StockItemForUpdateStockWithSellerStockCode
     */
    public function setQuantity($quantity = null)
    {
        // validation for constraint: int
        if (!is_null($quantity) && !(is_int($quantity) || ctype_digit($quantity))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($quantity, true), gettype($quantity)), __LINE__);
        }
        $this->quantity = $quantity;
        return $this;
    }
    /**
     * Get version value
     * @return int|null
     */
    public function getVersion()
    {
        return $this->version;
    }
    /**
     * Set version value
     * @param int $version
     * @return \StructType\StockItemForUpdateStockWithSellerStockCode
     */
    public function setVersion($version = null)
    {
        // validation for constraint: int
        if (!is_null($version) && !(is_int($version) || ctype_digit($version))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($version, true), gettype($version)), __LINE__);
        }
        $this->version = $version;
        return $this;
    }
}
