<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for UpdateProductPriceBySellerCodeRequest StructType
 * @subpackage Structs
 */
class UpdateProductPriceBySellerCodeRequest extends AbstractStructBase
{
    /**
     * The auth
     * @var \StructType\Authentication
     */
    public $auth;
    /**
     * The productSellerCode
     * @var string
     */
    public $productSellerCode;
    /**
     * The price
     * @var float
     */
    public $price;
    /**
     * The currencyType
     * @var int
     */
    public $currencyType;
    /**
     * The stockItems
     * @var \StructType\ProductSkuBasicRequestItemList
     */
    public $stockItems;
    /**
     * Constructor method for UpdateProductPriceBySellerCodeRequest
     * @uses UpdateProductPriceBySellerCodeRequest::setAuth()
     * @uses UpdateProductPriceBySellerCodeRequest::setProductSellerCode()
     * @uses UpdateProductPriceBySellerCodeRequest::setPrice()
     * @uses UpdateProductPriceBySellerCodeRequest::setCurrencyType()
     * @uses UpdateProductPriceBySellerCodeRequest::setStockItems()
     * @param \StructType\Authentication $auth
     * @param string $productSellerCode
     * @param float $price
     * @param int $currencyType
     * @param \StructType\ProductSkuBasicRequestItemList $stockItems
     */
    public function __construct(\StructType\Authentication $auth = null, $productSellerCode = null, $price = null, $currencyType = null, \StructType\ProductSkuBasicRequestItemList $stockItems = null)
    {
        $this
            ->setAuth($auth)
            ->setProductSellerCode($productSellerCode)
            ->setPrice($price)
            ->setCurrencyType($currencyType)
            ->setStockItems($stockItems);
    }
    /**
     * Get auth value
     * @return \StructType\Authentication|null
     */
    public function getAuth()
    {
        return $this->auth;
    }
    /**
     * Set auth value
     * @param \StructType\Authentication $auth
     * @return \StructType\UpdateProductPriceBySellerCodeRequest
     */
    public function setAuth(\StructType\Authentication $auth = null)
    {
        $this->auth = $auth;
        return $this;
    }
    /**
     * Get productSellerCode value
     * @return string|null
     */
    public function getProductSellerCode()
    {
        return $this->productSellerCode;
    }
    /**
     * Set productSellerCode value
     * @param string $productSellerCode
     * @return \StructType\UpdateProductPriceBySellerCodeRequest
     */
    public function setProductSellerCode($productSellerCode = null)
    {
        // validation for constraint: string
        if (!is_null($productSellerCode) && !is_string($productSellerCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($productSellerCode, true), gettype($productSellerCode)), __LINE__);
        }
        $this->productSellerCode = $productSellerCode;
        return $this;
    }
    /**
     * Get price value
     * @return float|null
     */
    public function getPrice()
    {
        return $this->price;
    }
    /**
     * Set price value
     * @param float $price
     * @return \StructType\UpdateProductPriceBySellerCodeRequest
     */
    public function setPrice($price = null)
    {
        // validation for constraint: float
        if (!is_null($price) && !(is_float($price) || is_numeric($price))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($price, true), gettype($price)), __LINE__);
        }
        $this->price = $price;
        return $this;
    }
    /**
     * Get currencyType value
     * @return int|null
     */
    public function getCurrencyType()
    {
        return $this->currencyType;
    }
    /**
     * Set currencyType value
     * @param int $currencyType
     * @return \StructType\UpdateProductPriceBySellerCodeRequest
     */
    public function setCurrencyType($currencyType = null)
    {
        // validation for constraint: int
        if (!is_null($currencyType) && !(is_int($currencyType) || ctype_digit($currencyType))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($currencyType, true), gettype($currencyType)), __LINE__);
        }
        $this->currencyType = $currencyType;
        return $this;
    }
    /**
     * Get stockItems value
     * @return \StructType\ProductSkuBasicRequestItemList|null
     */
    public function getStockItems()
    {
        return $this->stockItems;
    }
    /**
     * Set stockItems value
     * @param \StructType\ProductSkuBasicRequestItemList $stockItems
     * @return \StructType\UpdateProductPriceBySellerCodeRequest
     */
    public function setStockItems(\StructType\ProductSkuBasicRequestItemList $stockItems = null)
    {
        $this->stockItems = $stockItems;
        return $this;
    }
}
